-- author: DD ModPassion
-- date: 22.11.2021
-- copyright (C): DD ModPassion, All Rights Reserved
-- version: Farming Simulator 22
AttacherJointControllable = {} function AttacherJointControllable.prerequisitesPresent(specializations) return SpecializationUtil.hasSpecialization(AttacherJointControl, specializations) and SpecializationUtil.hasSpecialization(Attachable, specializations) end function AttacherJointControllable.registerOverwrittenFunctions(vehicleType) SpecializationUtil.registerOverwrittenFunction(vehicleType, "loadInputAttacherJoint", AttacherJointControllable.loadInputAttacherJoint) SpecializationUtil.registerOverwrittenFunction(vehicleType, "getIsLowered", AttacherJointControllable.getIsLowered) end function AttacherJointControllable.registerEventListeners(vehicleType) SpecializationUtil.registerEventListener(vehicleType, "onLoad", AttacherJointControllable) SpecializationUtil.registerEventListener(vehicleType, "onPostAttach", AttacherJointControllable) SpecializationUtil.registerEventListener(vehicleType, "onAIImplementStart", AttacherJointControllable) SpecializationUtil.registerEventListener(vehicleType, "onAIImplementEnd", AttacherJointControllable) SpecializationUtil.registerEventListener(vehicleType, "onTurnedOn", AttacherJointControllable) SpecializationUtil.registerEventListener(vehicleType, "onTurnedOff", AttacherJointControllable) end function AttacherJointControllable:onLoad(savegame) local spec = self.spec_attacherJointControl spec.attacherVehicle = nil spec.inputJointDescIndex = nil spec.jointDescIndex = nil spec.controls = {} local control = {} local controlFunc = "controlAttacherJointHeight" if controlFunc ~= nil and self[controlFunc] ~= nil then control.func = self[controlFunc] if control.func == self.controlAttacherJointHeight then spec.heightController = control end end local actionBindingName = "AXIS_FRONTLOADER_ARM2" if actionBindingName ~= nil and InputAction[actionBindingName] ~= nil then control.controlAction = InputAction[actionBindingName] end local iconName = "IMPLEMENT_ATTACHER_TRANS" if InputHelpElement.AXIS_ICON[iconName] == nil then iconName = (self.customEnvironment or "") .. iconName end control.axisActionIcon = iconName control.invertAxis = true control.mouseSpeedFactor = 0.25 control.moveAlpha = 0 control.moveAlphaSent = 0 control.moveAlphaLastManual = 0 spec.nameToControl[actionBindingName] = control table.insert(spec.controls, control) spec.dirtyFlagClient = self:getNextDirtyFlag() spec.dirtyFlagServer = self:getNextDirtyFlag() if #spec.controls > 0 then SpecializationUtil.registerEventListener(self, "onReadStream", AttacherJointControl) SpecializationUtil.registerEventListener(self, "onWriteStream", AttacherJointControl) SpecializationUtil.registerEventListener(self, "onReadUpdateStream", AttacherJointControl) SpecializationUtil.registerEventListener(self, "onWriteUpdateStream", AttacherJointControl) SpecializationUtil.registerEventListener(self, "onUpdate", AttacherJointControl) SpecializationUtil.registerEventListener(self, "onRegisterActionEvents", AttacherJointControl) SpecializationUtil.registerEventListener(self, "onPostAttach", AttacherJointControl) SpecializationUtil.registerEventListener(self, "onPreDetach", AttacherJointControl) end end function AttacherJointControllable:onPostAttach(attacherVehicle, inputJointDescIndex, jointDescIndex) local spec = self.spec_attacherJointControl spec.attacherVehicle = attacherVehicle spec.inputJointDescIndex = inputJointDescIndex spec.jointDescIndex = jointDescIndex end function AttacherJointControllable:onTurnedOn() local spec = self.spec_attacherJointControl if spec.jointDesc ~= nil then spec.jointDesc.allowsLowering = false end end function AttacherJointControllable:onTurnedOff() local spec = self.spec_attacherJointControl if spec.jointDesc ~= nil then spec.jointDesc.allowsLowering = false end end function AttacherJointControllable:onAIImplementStart() local spec = self.spec_attacherJointControl local inputAttacherJoints = self:getInputAttacherJoints() inputAttacherJoints[spec.inputJointDescIndex].isControllable = false if spec.jointDesc ~= nil then spec.jointDesc.allowsLowering = true spec.jointDesc.upperRotationOffset = spec.jointDesc.upperRotationOffsetBackup spec.jointDesc.lowerRotationOffset = spec.jointDesc.lowerRotationOffsetBackup spec.jointDesc = nil end end function AttacherJointControllable:onAIImplementEnd() local spec = self.spec_attacherJointControl local inputAttacherJoints = self:getInputAttacherJoints() inputAttacherJoints[spec.inputJointDescIndex].isControllable = true if inputAttacherJoints[spec.inputJointDescIndex] ~= nil and inputAttacherJoints[spec.inputJointDescIndex].isControllable then local attacherJoints = spec.attacherVehicle:getAttacherJoints() local jointDesc = attacherJoints[spec.jointDescIndex] jointDesc.allowsLowering = true jointDesc.upperRotationOffsetBackup = jointDesc.upperRotationOffset jointDesc.lowerRotationOffsetBackup = jointDesc.lowerRotationOffset spec.jointDesc = jointDesc for _, control in ipairs(spec.controls) do control.moveAlpha = control.func(self) end spec.heightTargetAlpha = spec.jointDesc.upperAlpha self:requestActionEventUpdate() end end function AttacherJointControllable:loadInputAttacherJoint(superFunc, xmlFile, key, inputAttacherJoint, i) if not superFunc(self, xmlFile, key, inputAttacherJoint, i) then return false end inputAttacherJoint.isControllable = xmlFile:getValue(key .. "#isControllable", true) return true end function AttacherJointControllable:getIsLowered(superFunc, default) local spec = self.spec_foldable if spec ~= nil then if self:getIsFoldMiddleAllowed() and spec.foldMiddleAnimTime ~= nil and spec.foldMiddleInputButton ~= nil then local ignoreFoldMiddle = false if spec.ignoreFoldMiddleWhileFolded and spec.foldMiddleAnimTime < self:getFoldAnimTime() then ignoreFoldMiddle = true end if not ignoreFoldMiddle then if spec.foldMoveDirection ~= 0 then if spec.foldMiddleDirection > 0 then if spec.foldAnimTime < spec.foldMiddleAnimTime + 0.01 then return spec.foldMoveDirection < 0 and spec.moveToMiddle ~= true end elseif spec.foldAnimTime > spec.foldMiddleAnimTime - 0.01 then return spec.foldMoveDirection > 0 and spec.moveToMiddle ~= true end elseif spec.foldMiddleDirection > 0 and spec.foldAnimTime < 0.01 then return true elseif spec.foldMiddleDirection < 0 and math.abs(1 - spec.foldAnimTime) < 0.01 then return true end return false else return superFunc(self, default) end end end spec = self.spec_attacherJointControl if spec.heightController then local showText = spec.jointDesc ~= nil if showText then if self:getControlAttacherJointDirection() then return false else return true end end end return superFunc(self, default) end